Description

Controllare che I'action di rimozione macchina da cluster faccia le cose giuste:

* Mostri solo i cluster in cui I'host & incluso fra le opzioni della select
¢ All'atto del clic rimuova correttamente I'host dal cluster

Associated revisions

Revision 569ace09 - 04/27/2017 12:05 PM - Mark Caglienzi

Add 'redirect_url' in response data for the specific case. refs: #174

Revision 0ada6301 - 04/27/2017 12:07 PM - Mark Caglienzi

Redirect to 'redirect_url' using jquery after successful action, defaulting to window.location. refs: #174

Revision bf1e4412 - 04/27/2017 12:07 PM - Mark Caglienzi
Merge branch 'master' into t174. refs: #174

History

#1 - 01/27/2017 02:05 PM - Mark Caglienzi

- Status changed from Nuovo to In elaborazione
#2 - 01/27/2017 05:00 PM - Mark Caglienzi

- Status changed from In elaborazione to Commenti

- Assignee changed from Mark Caglienzi to Christopher R. Gabriel

Ho fatto un po' di prove:

Host presente in un solo cluster
¢ Rimozione dell'host dal cluster
Errore 500 nella chiamata AJAX che elenca le actions perché I'host sparisce da /computers/NOMEDELLHOST, e quindi non ci sono actions.

¢ Host presente in due cluster
¢ Rimozione dell'host da uno dei due cluster
¢ Funzionamento corretto, I'host rimane presente solo nell'altro cluster, nessun errore né delle view ajax, né di quelle non ajax

Probabilmente € un bug dell'octofussd mock, che quando non trova un computer in nessun gruppo non lo aggiunge al tree (anche perché penso che
in produzione si sarebbero accorti di un bug del genere, negli anni)
#3 - 01/30/2017 11:44 AM - Christopher R. Gabriel
- Assignee changed from Christopher R. Gabriel to Mark Caglienzi

Se prendo un host in un solo cluster, e lo tolgo da quel cluster, mi rimane sulla pagina dell'host stesso, indicando via messages che l'azione €' andata
a buon fine, permettendomi poi di poterlo togliere nuovamente dallo stesso cluster da cui I'ho appena tolto.

Se hai il dettaglio dell'error 500 riferito a octofussd si puo' indagare la tua ipotesi, come lo si ottiene? oppure me lo incolli qua...

#4 - 02/01/2017 10:03 AM - Mark Caglienzi

- Status changed from Commenti to In elaborazione

#5 - 02/01/2017 02:16 PM - Mark Caglienzi
- Status changed from In elaborazione to Commenti

- Assignee changed from Mark Caglienzi to Christopher R. Gabriel
Hai quel comportamento li perché non c'e il reload alla fine della request. Se poi fai reload a mano vedi che non compaiono le actions. Non
compaiono perché la chiamata ajax che le genera da 500, perché non esiste piu quel computer nel tree.

L'errore 500 lo puoi vedere disabilitando il metodo dispatch() della ActionsAJAX (perché & fatta per funzionare solo via ajax) e visitando I'url
http://127.0.0.1:8000/host/actions/host/NOME_DELL HOST a mano, ed & questo:

Environment:

Request Method: GET
Request URL: http://127.0.0.1:8000/host/actions/host/daiiiiii

Django Version: 1.8.8
Python Version: 3.5.3
Installed Applications:
['django.contrib.sessions',
'django.contrib.messages’,
'whitenoise.runserver_nostatic',
'django.contrib.staticfiles',
'octonet',
'hostqueue.apps.HostQueue',
'firewall.apps.Firewall',
'dhcp.apps.Dhcp',
'dansguardian.apps.DansGuardian',
'host .apps.Host"',
'polygen.apps.Polygen',
'upgrade.apps.Upgrade',
'asterisk.apps.Asterisk’,
'samba.apps.Samba',
'users.apps.Users',
'script.apps.Script’',
'quota.apps.Quota',
'printers.apps.Printers’',
'auth.apps.Auth']
Installed Middleware:
['django.middleware.security.SecurityMiddleware',
'whitenoise.middleware.WhiteNoiseMiddleware',
'django.contrib.sessions.middleware.SessionMiddleware',
'django.middleware.common.CommonMiddleware',
'django.middleware.csrf.CsrfViewMiddleware',
'django.middleware.locale.LocaleMiddleware',
'octonet.middleware.AuthenticationMiddleware',
'django.contrib.messages.middleware.MessageMiddleware',
'django.middleware.clickjacking.XFrameOptionsMiddleware']

Traceback:
File "/home/mark/truelite/FUSS/octonet/django/core/handlers/base.py" in get_response
132. response = wrapped_callback (request, *callback_args, **callback_kwargs)
File "/home/mark/truelite/FUSS/octonet/django/views/generic/base.py" in view
71. return self.dispatch(request, *args, **kwargs)
File "/home/mark/truelite/FUSS/octonet/octonet/mixins.py" in dispatch
105. return super () .dispatch (request, *args, **kw)
File "/home/mark/truelite/FUSS/octonet/django/views/generic/base.py" in dispatch
89. return handler (request, *args, **kwargs)

File "/home/mark/truelite/FUSS/octonet/host/views.py" in get
234. data_list = self.get_sorted_actions (data)

File "/home/mark/truelite/FUSS/octonet/host/views.py" in get_sorted_actions
267. for action in actions_from_octofussd:

Exception Type: TypeError at /host/actions/host/daiiiiii
Exception Value: 'NoneType' object is not iterable

Se poi vai a vedere in octofussctl, noterai che quel computer (che nel mio esempio si chiama daiiiiii) € proprio sparito da /computers/nome_dell_host.
Invece se prendi un host che € in piu di un cluster, e lo rimuovi da un cluster, tutto questo non succede.

Dato che & un comportamento anomalo, e octofussd & in produzione da anni, mi vien da dire che sia un bug dell'octofussd mock, che non crea nel
tree la voce dell'host se non lo trova in nessun gruppo.

#6 - 02/16/2017 10:15 AM - Christopher R. Gabriel
- Assignee changed from Christopher R. Gabriel to Mark Caglienzi

Il comportamento lato octofussd e' corretto, perche' se un host non €' in nessun cluster, non esiste.

se si toglie un host da un cluster, e questo host non ha piu' cluster, allora direi che dopo I'operazione deve tornare all'elenco degli host, invece che
rimanere nella pagina dell'host che non esiste piu'.

#7 - 04/26/2017 04:10 PM - Mark Caglienzi

- Status changed from Commenti to In elaborazione

#8 - 04/27/2017 12:12 PM - Mark Caglienzi
- Status changed from In elaborazione to Commenti

- Assignee changed from Mark Caglienzi to Elena Grandi

520dc508:
e Aggiunto il parametro 'redirect_url' alla response della chiamata ajax che fa la action
e Se l'action e "rimuovi host da cluster" allora controlla che I'nost esista ancora (cioe che esista la voce /computers/NOME_DEL_COMPUTER), e
se non esiste setta redirect_url a host:list
e || javascript poi fa redirect a redirect_url, se c'é, e altrimenti lo fa a window.location, di fatto ricaricando la pagina come faceva gia prima
In questo modo si evita il redirect a una pagina vuota, per un host che non esiste pilu, e con una chiamata ajax in errore.

Inoltre & possibile personalizzare ulteriormente i redirect per ogni singola action, volendo.

Mergiato in master e pushato.
Pacchetto da rebuildare: octonet.

#9 - 04/28/2017 10:50 AM - Elena Grandi

- Assignee changed from Elena Grandi to Mark Caglienzi

Buildato e uploadato pacchetto con le modifiche.

#10 - 05/11/2017 10:58 AM - Christopher R. Gabriel

- Status changed from Commenti to Chiuso

Ok
